/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the M68k target                            *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 2;
using PredicateBitset = llvm::PredicateBitsetImpl<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(M68kInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(M68kInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ISelInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ISelInfo;
  static M68kInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static M68kInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const int64_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const std::array<const MachineOperand *, 3> &Operands) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ISelInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_IsPICBit = 0,
  Feature_IsNotPICBit = 1,
};

PredicateBitset M68kInstructionSelector::
computeAvailableModuleFeatures(const M68kSubtarget *Subtarget) const {
  PredicateBitset Features;
  if (TM.isPositionIndependent())
    Features.set(Feature_IsPICBit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_IsNotPICBit);
  return Features;
}

void M68kInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const M68kSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset M68kInstructionSelector::
computeAvailableFunctionFeatures(const M68kSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features;
  return Features;
}

// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
};
const static size_t NumTypeObjects = 3;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
};

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
const static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

// PatFrag predicates.
enum {
  GIPFP_I64_Predicate_Mximm16_1to8 = GIPFP_I64_Invalid + 1,
  GIPFP_I64_Predicate_Mximm32_1to8,
  GIPFP_I64_Predicate_Mximm8_1to8,
};
bool M68kInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GIPFP_I64_Predicate_Mximm16_1to8: {
     return Imm >= 1 && Imm <= 8; 
    llvm_unreachable("ImmediateCode should have returned");
    return false;
  }
  case GIPFP_I64_Predicate_Mximm32_1to8: {
     return Imm >= 1 && Imm <= 8; 
    llvm_unreachable("ImmediateCode should have returned");
    return false;
  }
  case GIPFP_I64_Predicate_Mximm8_1to8: {
     return Imm >= 1 && Imm <= 8; 
    llvm_unreachable("ImmediateCode should have returned");
    return false;
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool M68kInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool M68kInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool M68kInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const std::array<const MachineOperand *, 3> &Operands) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}

M68kInstructionSelector::ComplexMatcherMemFn
M68kInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// Custom renderers.
enum {
  GICR_Invalid,
};
M68kInstructionSelector::CustomRendererFn
M68kInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool M68kInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  MachineFunction &MF = *I.getParent()->getParent();
  MachineRegisterInfo &MRI = MF.getRegInfo();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  NewMIVector OutMIs;
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, OutMIs, State, ISelInfo, getMatchTable(), TII, MRI, TRI, RBI, AvailableFeatures, CoverageInfo)) {
    return true;
  }

  return false;
}

const int64_t *M68kInstructionSelector::getMatchTable() const {
  constexpr static int64_t MatchTable0[] = {
    GIM_SwitchOpcode, /*MI*/0, /*[*/45, 121, /*)*//*default:*//*Label 15*/ 2338,
    /*TargetOpcode::G_ADD*//*Label 0*/ 81,
    /*TargetOpcode::G_SUB*//*Label 1*/ 265, 0, 0, 0, 0, 0, 0, 0,
    /*TargetOpcode::G_AND*//*Label 2*/ 515,
    /*TargetOpcode::G_OR*//*Label 3*/ 699,
    /*TargetOpcode::G_XOR*//*Label 4*/ 883, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    /*TargetOpcode::G_ANYEXT*//*Label 5*/ 1067,
    /*TargetOpcode::G_TRUNC*//*Label 6*/ 1117,
    /*TargetOpcode::G_CONSTANT*//*Label 7*/ 1155, 0, 0, 0,
    /*TargetOpcode::G_SEXT*//*Label 8*/ 1273, 0,
    /*TargetOpcode::G_ZEXT*//*Label 9*/ 1323,
    /*TargetOpcode::G_SHL*//*Label 10*/ 1373,
    /*TargetOpcode::G_LSHR*//*Label 11*/ 1566,
    /*TargetOpcode::G_ASHR*//*Label 12*/ 1759, 0, 0,
    /*TargetOpcode::G_ROTR*//*Label 13*/ 1952,
    /*TargetOpcode::G_ROTL*//*Label 14*/ 2145,
    // Label 0: @81
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 19*/ 264,
    /*GILLT_s8*//*Label 16*/ 90,
    /*GILLT_s16*//*Label 17*/ 148,
    /*GILLT_s32*//*Label 18*/ 206,
    // Label 16: @90
    GIM_Try, /*On fail goto*//*Label 20*/ 147,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 21*/ 134, // Rule ID 572 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (add:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (ADD8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ADD8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 572,
        GIR_Done,
      // Label 21: @134
      GIM_Try, /*On fail goto*//*Label 22*/ 146, // Rule ID 560 //
        // (add:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ADD8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ADD8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 560,
        GIR_Done,
      // Label 22: @146
      GIM_Reject,
    // Label 20: @147
    GIM_Reject,
    // Label 17: @148
    GIM_Try, /*On fail goto*//*Label 23*/ 205,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 24*/ 192, // Rule ID 573 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (ADD16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ADD16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 573,
        GIR_Done,
      // Label 24: @192
      GIM_Try, /*On fail goto*//*Label 25*/ 204, // Rule ID 561 //
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ADD16dr:{ *:[i16] }:{ *:[i8] } MxXRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ADD16dr,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 561,
        GIR_Done,
      // Label 25: @204
      GIM_Reject,
    // Label 23: @205
    GIM_Reject,
    // Label 18: @206
    GIM_Try, /*On fail goto*//*Label 26*/ 263,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 27*/ 250, // Rule ID 574 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (ADD32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ADD32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 574,
        GIR_Done,
      // Label 27: @250
      GIM_Try, /*On fail goto*//*Label 28*/ 262, // Rule ID 562 //
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ADD32dr:{ *:[i32] }:{ *:[i8] } MxXRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ADD32dr,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 562,
        GIR_Done,
      // Label 28: @262
      GIM_Reject,
    // Label 26: @263
    GIM_Reject,
    // Label 19: @264
    GIM_Reject,
    // Label 1: @265
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 32*/ 514,
    /*GILLT_s8*//*Label 29*/ 274,
    /*GILLT_s16*//*Label 30*/ 354,
    /*GILLT_s32*//*Label 31*/ 434,
    // Label 29: @274
    GIM_Try, /*On fail goto*//*Label 33*/ 353,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 34*/ 310, // Rule ID 424 //
        GIM_CheckConstantInt, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i8] } 0:{ *:[i8] }, i8:{ *:[i8] }:$src)  =>  (NEG8d:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::NEG8d,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // src
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 424,
        GIR_Done,
      // Label 34: @310
      GIM_Try, /*On fail goto*//*Label 35*/ 340, // Rule ID 611 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sub:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (SUB8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SUB8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 611,
        GIR_Done,
      // Label 35: @340
      GIM_Try, /*On fail goto*//*Label 36*/ 352, // Rule ID 599 //
        // (sub:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (SUB8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SUB8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 599,
        GIR_Done,
      // Label 36: @352
      GIM_Reject,
    // Label 33: @353
    GIM_Reject,
    // Label 30: @354
    GIM_Try, /*On fail goto*//*Label 37*/ 433,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 38*/ 390, // Rule ID 426 //
        GIM_CheckConstantInt, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i16] } 0:{ *:[i16] }, i16:{ *:[i16] }:$src)  =>  (NEG16d:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::NEG16d,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // src
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 426,
        GIR_Done,
      // Label 38: @390
      GIM_Try, /*On fail goto*//*Label 39*/ 420, // Rule ID 612 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sub:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (SUB16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SUB16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 612,
        GIR_Done,
      // Label 39: @420
      GIM_Try, /*On fail goto*//*Label 40*/ 432, // Rule ID 600 //
        // (sub:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (SUB16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SUB16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 600,
        GIR_Done,
      // Label 40: @432
      GIM_Reject,
    // Label 37: @433
    GIM_Reject,
    // Label 31: @434
    GIM_Try, /*On fail goto*//*Label 41*/ 513,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 42*/ 470, // Rule ID 428 //
        GIM_CheckConstantInt, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$src)  =>  (NEG32d:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::NEG32d,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // src
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 428,
        GIR_Done,
      // Label 42: @470
      GIM_Try, /*On fail goto*//*Label 43*/ 500, // Rule ID 613 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sub:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (SUB32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SUB32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 613,
        GIR_Done,
      // Label 43: @500
      GIM_Try, /*On fail goto*//*Label 44*/ 512, // Rule ID 601 //
        // (sub:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (SUB32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SUB32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 601,
        GIR_Done,
      // Label 44: @512
      GIM_Reject,
    // Label 41: @513
    GIM_Reject,
    // Label 32: @514
    GIM_Reject,
    // Label 2: @515
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 48*/ 698,
    /*GILLT_s8*//*Label 45*/ 524,
    /*GILLT_s16*//*Label 46*/ 582,
    /*GILLT_s32*//*Label 47*/ 640,
    // Label 45: @524
    GIM_Try, /*On fail goto*//*Label 49*/ 581,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 50*/ 568, // Rule ID 641 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (and:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (AND8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::AND8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 641,
        GIR_Done,
      // Label 50: @568
      GIM_Try, /*On fail goto*//*Label 51*/ 580, // Rule ID 638 //
        // (and:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (AND8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::AND8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 638,
        GIR_Done,
      // Label 51: @580
      GIM_Reject,
    // Label 49: @581
    GIM_Reject,
    // Label 46: @582
    GIM_Try, /*On fail goto*//*Label 52*/ 639,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 53*/ 626, // Rule ID 642 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (and:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (AND16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::AND16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 642,
        GIR_Done,
      // Label 53: @626
      GIM_Try, /*On fail goto*//*Label 54*/ 638, // Rule ID 639 //
        // (and:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (AND16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::AND16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 639,
        GIR_Done,
      // Label 54: @638
      GIM_Reject,
    // Label 52: @639
    GIM_Reject,
    // Label 47: @640
    GIM_Try, /*On fail goto*//*Label 55*/ 697,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 56*/ 684, // Rule ID 643 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (AND32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::AND32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 643,
        GIR_Done,
      // Label 56: @684
      GIM_Try, /*On fail goto*//*Label 57*/ 696, // Rule ID 640 //
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (AND32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::AND32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 640,
        GIR_Done,
      // Label 57: @696
      GIM_Reject,
    // Label 55: @697
    GIM_Reject,
    // Label 48: @698
    GIM_Reject,
    // Label 3: @699
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 61*/ 882,
    /*GILLT_s8*//*Label 58*/ 708,
    /*GILLT_s16*//*Label 59*/ 766,
    /*GILLT_s32*//*Label 60*/ 824,
    // Label 58: @708
    GIM_Try, /*On fail goto*//*Label 62*/ 765,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 63*/ 752, // Rule ID 647 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (or:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (OR8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::OR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 647,
        GIR_Done,
      // Label 63: @752
      GIM_Try, /*On fail goto*//*Label 64*/ 764, // Rule ID 644 //
        // (or:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (OR8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::OR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 644,
        GIR_Done,
      // Label 64: @764
      GIM_Reject,
    // Label 62: @765
    GIM_Reject,
    // Label 59: @766
    GIM_Try, /*On fail goto*//*Label 65*/ 823,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 66*/ 810, // Rule ID 648 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (or:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (OR16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::OR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 648,
        GIR_Done,
      // Label 66: @810
      GIM_Try, /*On fail goto*//*Label 67*/ 822, // Rule ID 645 //
        // (or:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (OR16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::OR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 645,
        GIR_Done,
      // Label 67: @822
      GIM_Reject,
    // Label 65: @823
    GIM_Reject,
    // Label 60: @824
    GIM_Try, /*On fail goto*//*Label 68*/ 881,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 69*/ 868, // Rule ID 649 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (OR32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::OR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 649,
        GIR_Done,
      // Label 69: @868
      GIM_Try, /*On fail goto*//*Label 70*/ 880, // Rule ID 646 //
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (OR32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::OR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 646,
        GIR_Done,
      // Label 70: @880
      GIM_Reject,
    // Label 68: @881
    GIM_Reject,
    // Label 61: @882
    GIM_Reject,
    // Label 4: @883
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 74*/ 1066,
    /*GILLT_s8*//*Label 71*/ 892,
    /*GILLT_s16*//*Label 72*/ 950,
    /*GILLT_s32*//*Label 73*/ 1008,
    // Label 71: @892
    GIM_Try, /*On fail goto*//*Label 75*/ 949,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 76*/ 936, // Rule ID 653 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (xor:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (XOR8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::XOR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 653,
        GIR_Done,
      // Label 76: @936
      GIM_Try, /*On fail goto*//*Label 77*/ 948, // Rule ID 650 //
        // (xor:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (XOR8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::XOR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 650,
        GIR_Done,
      // Label 77: @948
      GIM_Reject,
    // Label 75: @949
    GIM_Reject,
    // Label 72: @950
    GIM_Try, /*On fail goto*//*Label 78*/ 1007,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 79*/ 994, // Rule ID 654 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (XOR16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::XOR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 654,
        GIR_Done,
      // Label 79: @994
      GIM_Try, /*On fail goto*//*Label 80*/ 1006, // Rule ID 651 //
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (XOR16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::XOR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 651,
        GIR_Done,
      // Label 80: @1006
      GIM_Reject,
    // Label 78: @1007
    GIM_Reject,
    // Label 73: @1008
    GIM_Try, /*On fail goto*//*Label 81*/ 1065,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 82*/ 1052, // Rule ID 655 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (XOR32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::XOR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 655,
        GIR_Done,
      // Label 82: @1052
      GIM_Try, /*On fail goto*//*Label 83*/ 1064, // Rule ID 652 //
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (XOR32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::XOR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 652,
        GIR_Done,
      // Label 83: @1064
      GIM_Reject,
    // Label 81: @1065
    GIM_Reject,
    // Label 74: @1066
    GIM_Reject,
    // Label 5: @1067
    GIM_Try, /*On fail goto*//*Label 84*/ 1116,
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/0, 2, /*)*//*default:*//*Label 87*/ 1115,
      /*GILLT_s8*//*Label 85*/ 1081,
      /*GILLT_s16*//*Label 86*/ 1098,
      // Label 85: @1081
      GIM_Try, /*On fail goto*//*Label 88*/ 1097, // Rule ID 521 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
        // (anyext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVZXd32d8,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 521,
        GIR_Done,
      // Label 88: @1097
      GIM_Reject,
      // Label 86: @1098
      GIM_Try, /*On fail goto*//*Label 89*/ 1114, // Rule ID 525 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
        // (anyext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVZXd32d16,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 525,
        GIR_Done,
      // Label 89: @1114
      GIM_Reject,
      // Label 87: @1115
      GIM_Reject,
    // Label 84: @1116
    GIM_Reject,
    // Label 6: @1117
    GIM_Try, /*On fail goto*//*Label 90*/ 1154, // Rule ID 529 //
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
      // (trunc:{ *:[i16] } i32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } MxXRD32:{ *:[i32] }:$src, MxSubRegIndex16Lo:{ *:[i32] })
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/TargetOpcode::COPY,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/2, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, M68k::XR16RegClassID,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, M68k::XR32RegClassID,
      // GIR_Coverage, 529,
      GIR_Done,
    // Label 90: @1154
    GIM_Reject,
    // Label 7: @1155
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 94*/ 1272,
    /*GILLT_s8*//*Label 91*/ 1164,
    /*GILLT_s16*//*Label 92*/ 1186,
    /*GILLT_s32*//*Label 93*/ 1229,
    // Label 91: @1164
    GIM_Try, /*On fail goto*//*Label 95*/ 1185, // Rule ID 6 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i8] }):$src  =>  (MOV8di:{ *:[i8] }:{ *:[i8] } (imm:{ *:[i8] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV8di,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 6,
      GIR_Done,
    // Label 95: @1185
    GIM_Reject,
    // Label 92: @1186
    GIM_Try, /*On fail goto*//*Label 96*/ 1207, // Rule ID 13 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR16RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i16] }):$src  =>  (MOV16ri:{ *:[i16] }:{ *:[i8] } (imm:{ *:[i16] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV16ri,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 13,
      GIR_Done,
    // Label 96: @1207
    GIM_Try, /*On fail goto*//*Label 97*/ 1228, // Rule ID 20 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::AR16RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i16] }):$src  =>  (MOV16ai:{ *:[i16] }:{ *:[i8] } (imm:{ *:[i16] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV16ai,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 20,
      GIR_Done,
    // Label 97: @1228
    GIM_Reject,
    // Label 93: @1229
    GIM_Try, /*On fail goto*//*Label 98*/ 1250, // Rule ID 27 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$src  =>  (MOV32ri:{ *:[i32] }:{ *:[i8] } (imm:{ *:[i32] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV32ri,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 27,
      GIR_Done,
    // Label 98: @1250
    GIM_Try, /*On fail goto*//*Label 99*/ 1271, // Rule ID 34 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::AR32RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$src  =>  (MOV32ai:{ *:[i32] }:{ *:[i8] } (imm:{ *:[i32] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV32ai,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 34,
      GIR_Done,
    // Label 99: @1271
    GIM_Reject,
    // Label 94: @1272
    GIM_Reject,
    // Label 8: @1273
    GIM_Try, /*On fail goto*//*Label 100*/ 1322,
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/0, 2, /*)*//*default:*//*Label 103*/ 1321,
      /*GILLT_s8*//*Label 101*/ 1287,
      /*GILLT_s16*//*Label 102*/ 1304,
      // Label 101: @1287
      GIM_Try, /*On fail goto*//*Label 104*/ 1303, // Rule ID 497 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
        // (sext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVSXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVSXd32d8,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 497,
        GIR_Done,
      // Label 104: @1303
      GIM_Reject,
      // Label 102: @1304
      GIM_Try, /*On fail goto*//*Label 105*/ 1320, // Rule ID 501 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
        // (sext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVSXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVSXd32d16,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 501,
        GIR_Done,
      // Label 105: @1320
      GIM_Reject,
      // Label 103: @1321
      GIM_Reject,
    // Label 100: @1322
    GIM_Reject,
    // Label 9: @1323
    GIM_Try, /*On fail goto*//*Label 106*/ 1372,
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/0, 2, /*)*//*default:*//*Label 109*/ 1371,
      /*GILLT_s8*//*Label 107*/ 1337,
      /*GILLT_s16*//*Label 108*/ 1354,
      // Label 107: @1337
      GIM_Try, /*On fail goto*//*Label 110*/ 1353, // Rule ID 509 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
        // (zext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVZXd32d8,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 509,
        GIR_Done,
      // Label 110: @1353
      GIM_Reject,
      // Label 108: @1354
      GIM_Try, /*On fail goto*//*Label 111*/ 1370, // Rule ID 513 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
        // (zext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVZXd32d16,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 513,
        GIR_Done,
      // Label 111: @1370
      GIM_Reject,
      // Label 109: @1371
      GIM_Reject,
    // Label 106: @1372
    GIM_Reject,
    // Label 10: @1373
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 115*/ 1565,
    /*GILLT_s8*//*Label 112*/ 1382,
    /*GILLT_s16*//*Label 113*/ 1443,
    /*GILLT_s32*//*Label 114*/ 1504,
    // Label 112: @1382
    GIM_Try, /*On fail goto*//*Label 116*/ 1442,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 117*/ 1429, // Rule ID 238 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (shl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (SHL8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SHL8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 238,
        GIR_Done,
      // Label 117: @1429
      GIM_Try, /*On fail goto*//*Label 118*/ 1441, // Rule ID 235 //
        // (shl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (SHL8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SHL8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 235,
        GIR_Done,
      // Label 118: @1441
      GIM_Reject,
    // Label 116: @1442
    GIM_Reject,
    // Label 113: @1443
    GIM_Try, /*On fail goto*//*Label 119*/ 1503,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 120*/ 1490, // Rule ID 239 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (SHL16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SHL16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 239,
        GIR_Done,
      // Label 120: @1490
      GIM_Try, /*On fail goto*//*Label 121*/ 1502, // Rule ID 236 //
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (SHL16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SHL16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 236,
        GIR_Done,
      // Label 121: @1502
      GIM_Reject,
    // Label 119: @1503
    GIM_Reject,
    // Label 114: @1504
    GIM_Try, /*On fail goto*//*Label 122*/ 1564,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 123*/ 1551, // Rule ID 240 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (SHL32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SHL32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 240,
        GIR_Done,
      // Label 123: @1551
      GIM_Try, /*On fail goto*//*Label 124*/ 1563, // Rule ID 237 //
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (SHL32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SHL32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 237,
        GIR_Done,
      // Label 124: @1563
      GIM_Reject,
    // Label 122: @1564
    GIM_Reject,
    // Label 115: @1565
    GIM_Reject,
    // Label 11: @1566
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 128*/ 1758,
    /*GILLT_s8*//*Label 125*/ 1575,
    /*GILLT_s16*//*Label 126*/ 1636,
    /*GILLT_s32*//*Label 127*/ 1697,
    // Label 125: @1575
    GIM_Try, /*On fail goto*//*Label 129*/ 1635,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 130*/ 1622, // Rule ID 244 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (srl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (LSR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::LSR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 244,
        GIR_Done,
      // Label 130: @1622
      GIM_Try, /*On fail goto*//*Label 131*/ 1634, // Rule ID 241 //
        // (srl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (LSR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::LSR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 241,
        GIR_Done,
      // Label 131: @1634
      GIM_Reject,
    // Label 129: @1635
    GIM_Reject,
    // Label 126: @1636
    GIM_Try, /*On fail goto*//*Label 132*/ 1696,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 133*/ 1683, // Rule ID 245 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (LSR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::LSR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 245,
        GIR_Done,
      // Label 133: @1683
      GIM_Try, /*On fail goto*//*Label 134*/ 1695, // Rule ID 242 //
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (LSR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::LSR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 242,
        GIR_Done,
      // Label 134: @1695
      GIM_Reject,
    // Label 132: @1696
    GIM_Reject,
    // Label 127: @1697
    GIM_Try, /*On fail goto*//*Label 135*/ 1757,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 136*/ 1744, // Rule ID 246 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (LSR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::LSR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 246,
        GIR_Done,
      // Label 136: @1744
      GIM_Try, /*On fail goto*//*Label 137*/ 1756, // Rule ID 243 //
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (LSR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::LSR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 243,
        GIR_Done,
      // Label 137: @1756
      GIM_Reject,
    // Label 135: @1757
    GIM_Reject,
    // Label 128: @1758
    GIM_Reject,
    // Label 12: @1759
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 141*/ 1951,
    /*GILLT_s8*//*Label 138*/ 1768,
    /*GILLT_s16*//*Label 139*/ 1829,
    /*GILLT_s32*//*Label 140*/ 1890,
    // Label 138: @1768
    GIM_Try, /*On fail goto*//*Label 142*/ 1828,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 143*/ 1815, // Rule ID 250 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sra:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ASR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ASR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 250,
        GIR_Done,
      // Label 143: @1815
      GIM_Try, /*On fail goto*//*Label 144*/ 1827, // Rule ID 247 //
        // (sra:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ASR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ASR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 247,
        GIR_Done,
      // Label 144: @1827
      GIM_Reject,
    // Label 142: @1828
    GIM_Reject,
    // Label 139: @1829
    GIM_Try, /*On fail goto*//*Label 145*/ 1889,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 146*/ 1876, // Rule ID 251 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ASR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ASR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 251,
        GIR_Done,
      // Label 146: @1876
      GIM_Try, /*On fail goto*//*Label 147*/ 1888, // Rule ID 248 //
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ASR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ASR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 248,
        GIR_Done,
      // Label 147: @1888
      GIM_Reject,
    // Label 145: @1889
    GIM_Reject,
    // Label 140: @1890
    GIM_Try, /*On fail goto*//*Label 148*/ 1950,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 149*/ 1937, // Rule ID 252 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ASR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ASR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 252,
        GIR_Done,
      // Label 149: @1937
      GIM_Try, /*On fail goto*//*Label 150*/ 1949, // Rule ID 249 //
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ASR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ASR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 249,
        GIR_Done,
      // Label 150: @1949
      GIM_Reject,
    // Label 148: @1950
    GIM_Reject,
    // Label 141: @1951
    GIM_Reject,
    // Label 13: @1952
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 154*/ 2144,
    /*GILLT_s8*//*Label 151*/ 1961,
    /*GILLT_s16*//*Label 152*/ 2022,
    /*GILLT_s32*//*Label 153*/ 2083,
    // Label 151: @1961
    GIM_Try, /*On fail goto*//*Label 155*/ 2021,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 156*/ 2008, // Rule ID 262 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotr:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ROR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 262,
        GIR_Done,
      // Label 156: @2008
      GIM_Try, /*On fail goto*//*Label 157*/ 2020, // Rule ID 259 //
        // (rotr:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ROR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 259,
        GIR_Done,
      // Label 157: @2020
      GIM_Reject,
    // Label 155: @2021
    GIM_Reject,
    // Label 152: @2022
    GIM_Try, /*On fail goto*//*Label 158*/ 2082,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 159*/ 2069, // Rule ID 263 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotr:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ROR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 263,
        GIR_Done,
      // Label 159: @2069
      GIM_Try, /*On fail goto*//*Label 160*/ 2081, // Rule ID 260 //
        // (rotr:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ROR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 260,
        GIR_Done,
      // Label 160: @2081
      GIM_Reject,
    // Label 158: @2082
    GIM_Reject,
    // Label 153: @2083
    GIM_Try, /*On fail goto*//*Label 161*/ 2143,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 162*/ 2130, // Rule ID 264 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ROR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 264,
        GIR_Done,
      // Label 162: @2130
      GIM_Try, /*On fail goto*//*Label 163*/ 2142, // Rule ID 261 //
        // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ROR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 261,
        GIR_Done,
      // Label 163: @2142
      GIM_Reject,
    // Label 161: @2143
    GIM_Reject,
    // Label 154: @2144
    GIM_Reject,
    // Label 14: @2145
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 167*/ 2337,
    /*GILLT_s8*//*Label 164*/ 2154,
    /*GILLT_s16*//*Label 165*/ 2215,
    /*GILLT_s32*//*Label 166*/ 2276,
    // Label 164: @2154
    GIM_Try, /*On fail goto*//*Label 168*/ 2214,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 169*/ 2201, // Rule ID 256 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ROL8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROL8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 256,
        GIR_Done,
      // Label 169: @2201
      GIM_Try, /*On fail goto*//*Label 170*/ 2213, // Rule ID 253 //
        // (rotl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ROL8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROL8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 253,
        GIR_Done,
      // Label 170: @2213
      GIM_Reject,
    // Label 168: @2214
    GIM_Reject,
    // Label 165: @2215
    GIM_Try, /*On fail goto*//*Label 171*/ 2275,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 172*/ 2262, // Rule ID 257 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ROL16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROL16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 257,
        GIR_Done,
      // Label 172: @2262
      GIM_Try, /*On fail goto*//*Label 173*/ 2274, // Rule ID 254 //
        // (rotl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ROL16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROL16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 254,
        GIR_Done,
      // Label 173: @2274
      GIM_Reject,
    // Label 171: @2275
    GIM_Reject,
    // Label 166: @2276
    GIM_Try, /*On fail goto*//*Label 174*/ 2336,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 175*/ 2323, // Rule ID 258 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ROL32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROL32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 258,
        GIR_Done,
      // Label 175: @2323
      GIM_Try, /*On fail goto*//*Label 176*/ 2335, // Rule ID 255 //
        // (rotl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ROL32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROL32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 255,
        GIR_Done,
      // Label 176: @2335
      GIM_Reject,
    // Label 174: @2336
    GIM_Reject,
    // Label 167: @2337
    GIM_Reject,
    // Label 15: @2338
    GIM_Reject,
    };
  return MatchTable0;
}
#endif // ifdef GET_GLOBALISEL_IMPL
#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const M68kSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const M68kSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
